Name :      cryptobone
Version:    1.0.1   
Release:    1%{?dist}
Summary:    Secure Communication Under Your Control      

Group:      Applications/Internet         
License:    BSD       
URL:        https://crypto-bone.com      
Source0:    https://crypto-bone.com/release/source/cryptobone-1.0.1.tar.gz       
BuildArch:  x86_64

BuildRequires: libbsd-devel
BuildRequires: gcc

Requires: bash    
Requires: python
Requires: tkinter
Requires: openssh-askpass
Requires: fetchmail
Requires: base64
Requires: postfix
Requires: socat
Requires: cryptsetup
Requires: openssh

Conflicts: cryptobone-extern

%description
The Crypto Bone is a secure messaging system that makes sure a user's
email is always encrypted without burdening the user with the message
key management. Based on a GUI and a separate daemon, both ease-of-use
and security are assured by a novel approach to encryption key management.

While the message keys are secured by a daemon running on the Linux machine,
additional protection can be achieved by using an external device for storing
encryption keys. This external device can be another Linux computer dedicated
to this task or a Beagle Bone or a Raspberry Pi.  (https://crypto-bone.com)

%prep
# empty

%setup
# emtpy

%build
%configure
make %{?_smp_mflags}

%install
%make_install

cd $RPM_BUILD_ROOT
tar xvpzf $RPM_BUILD_DIR/cryptobone.tgz
sha256sum $(find usr -type f) $(find etc -type f) > fingerprints
cat fingerprints
mv fingerprints usr/lib/cryptobone/fingerprints

%pre
# empty

%post
# this script is run after the packet's installation 
chmod 700 /usr/lib/cryptobone
if [ $1 = "1" ]
then
     # installation only, not running after update
     if ! systemctl is-active postfix > /dev/null
     then
          systemctl enable postfix
     fi 
     cp /usr/lib/cryptobone/GUI/cryptobone /usr/local/bin
     if [ ! -f /var/spool/cron/root ]
     then
          echo "* * * * * /usr/lib/cryptobone/cron.fetchmail 2> /dev/null > /dev/null" > /var/spool/cron/root 
     else     
          if !  grep "cron.fetchmail" /var/spool/cron/root > /dev/null
	  then
	       echo "* * * * * /usr/lib/cryptobone/cron.fetchmail 2> /dev/null > /dev/null" >> /var/spool/cron/root 
	  fi     
     fi
     ln -s /usr/lib/cryptobone/version /usr/lib/cryptobone/ALLINONE 2>/dev/null
     cp /usr/lib/cryptobone/GUI/cryptobone.jpg /usr/share/icons/default
     desktop-file-install --dir /usr/share/applications -m 755 /usr/lib/cryptobone/GUI/cryptobone.desktop
     #cp /usr/lib/cryptobone/GUI/cryptobone.desktop /usr/share/applications
     /usr/lib/cryptobone/sudogetuser
     if ! systemctl is-active sshd > /dev/null
     then
          systemctl enable sshd 2> /dev/null > /dev/null
     fi	  
     
     systemctl enable cryptoboned 2> /dev/null > /dev/null
     chkconfig --add cryptoboned 2> /dev/null > /dev/null
     echo "Please reboot your computer as the crypto bone daemon will start only while booting."
fi

if [ $1 = "2" ]
then
     # update POST installation tasks
     cp /usr/lib/cryptobone/GUI/cryptobone /usr/local/bin
fi


%preun
# this script is run before the package is removed
if [ $1 = "0" ]
then
     # removal only, not running before update
     systemctl stop cryptoboned 2> /dev/null > /dev/null
     systemctl disable cryptoboned 2> /dev/null > /dev/null
     chkconfig --del cryptoboned
     umount /usr/lib/cryptobone/keys 2> /dev/null
     rm -f /etc/sudoers.d/cbcontrol 2> /dev/null
     grep -v "cbcontrol" /var/spool/cron/root > /root/newcrontab
     cp /root/newcrontab  /var/spool/cron/root
     grep -v "cron.fetchmail" /var/spool/cron/root > /root/newcrontab 
     cp /root/newcrontab /var/spool/cron/root
     if [ -f /usr/lib/cryptobone/bootswitch ] 
     then
          chattr -i /usr/lib/cryptobone/bootswitch 2> /dev/null > /dev/null
     fi	  
     rm -f /usr/local/bin/cryptobone
     rm -rf /dev/shm/RAM
     # delete all config files in /usr/lib/cryptobone
     rm -rf /usr/lib/cryptobone/keys/* 2> /dev/null > /dev/null
     rm -rf /usr/lib/cryptobone/cryptobone/* 2> /dev/null > /dev/null
     rm -f /usr/lib/cryptobone/database* 2> /dev/null > /dev/null
     rm -f /usr/lib/cryptobone/cbb.config 2> /dev/null > /dev/null
     rm -f /usr/lib/cryptobone/bootswitch 2> /dev/null > /dev/null
     rm -f /usr/lib/cryptobone/keys.tgz 2> /dev/null > /dev/null
     rm -f /usr/lib/cryptobone/masterkey 2> /dev/null > /dev/null
     rm -f /usr/lib/cryptobone/pinghost 2> /dev/null > /dev/null
     rm -f /usr/share/applications/cryptobone.desktop 2> /dev/null > /dev/null
     rm -f /usr/share/icons/default/cryptobone.jpg 2> /dev/null > /dev/null
fi
if [ $1 = "1" ]
then
     # update PRE removal tasks
     echo
fi

%postun
# this script is run after the package is removed
if [ $1 = "0" ]
then
     rm -rf /usr/lib/cryptobone 2> /dev/null > /dev/null
     rm -rf /usr/share/doc/cryptobone 2> /dev/null > /dev/null
fi


%clean
rm -rf $RPM_BUILD_ROOT


%files
%attr(700,root,root) /etc/init.d/cryptoboned
/etc/systemd/system/cryptoboned.service
%attr(700,root,root) /usr/lib/cryptobone
%attr(700,root,root) /usr/lib/cryptobone/ALLINONE
/usr/lib/cryptobone/GUI
/usr/lib/cryptobone/GUI/cryptobone
/usr/lib/cryptobone/GUI/cryptobone.desktop
/usr/lib/cryptobone/GUI/cryptobone.jpg
%attr(700,root,root) /usr/lib/cryptobone/bin
%attr(700,root,root) /usr/lib/cryptobone/bin/analysebatchfile
%attr(700,root,root) /usr/lib/cryptobone/bin/cbb-poweroff
%attr(700,root,root) /usr/lib/cryptobone/bin/createfetchmailrc
%attr(700,root,root) /usr/lib/cryptobone/bin/processmessage
%attr(700,root,root) /usr/lib/cryptobone/bin/restoremessages
%attr(700,root,root) /usr/lib/cryptobone/bin/savemessages
%attr(700,root,root) /usr/lib/cryptobone/bin/sendmessage
%attr(700,root,root) /usr/lib/cryptobone/cbcontrol
%attr(700,root,root) /usr/lib/cryptobone/cbcontrol.functions
%attr(700,root,root) /usr/lib/cryptobone/check
%attr(700,root,root) /usr/lib/cryptobone/createmasterkey
%attr(700,root,root) /usr/lib/cryptobone/cron.fetchmail
%attr(700,root,root) /usr/lib/cryptobone/cryptobone
%attr(700,root,root) /usr/lib/cryptobone/cryptoboned
/usr/lib/cryptobone/fingerprints
%attr(700,root,root) /usr/lib/cryptobone/getIP
%attr(700,root,root) /usr/lib/cryptobone/getlocalsecret
%attr(700,root,root) /usr/lib/cryptobone/keys
/usr/lib/cryptobone/libcl.so.3.4.3
/usr/lib/cryptobone/openpgp
%attr(700,root,root) /usr/lib/cryptobone/rc.local
%attr(700,root,root) /usr/lib/cryptobone/sudogetuser
/usr/lib/cryptobone/version
%doc /usr/lib/cryptobone/src-1.0.tgz
/usr/share/man/man8/cryptoboned.8.gz
/usr/share/man/man8/openpgp.8.gz
/usr/share/man/man8/cbcontrol.8.gz

%license  /usr/lib/cryptobone/COPYING
%license  /usr/lib/cryptobone/COPYING-cryptlib
%doc /usr/lib/cryptobone/README
%doc /usr/lib/cryptobone/README-cryptlib

%changelog

* Fri Feb 19 2016 Senderek Web Security <innovation@senderek.ie> - 1.0.1-1
	RC for Fedora package review

* Sat Feb 13 2016 Senderek Web Security <innovation@senderek.ie> - 1.0-2
	update of cl343_beta.zip source code by Peter Gutmann
	removing all previous patches

* Sun Jan 24 2016 Senderek Web Security <innovation@senderek.ie> - 1.0-1
  	Initial release of the first version ready for general use.

* Sat Jan 16 2016 Senderek Web Security <innovation@senderek.ie> - 0.99-3
	Security Update: introduction of the cryptobone daemon in version 0.99

* Sun Jul 26 2015 Senderek Web Security <innovation@senderek.ie>
	Initial RPM build
